VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SystemInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' General Windows System Information
'
' 29 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' Local Variables

Private CurSysInfo As SYSTEMINFO_STRUCT


'------------------------------------------------------------------
' Public Constants for API calls

Public Enum InfoSystemMetrics
  SM_CMETRICS = 44
  SM_CMOUSEBUTTONS = 43
  SM_CXBORDER = 5
  SM_CXCURSOR = 13
  SM_CXDLGFRAME = 7
  SM_CXDOUBLECLK = 36
  SM_CXFIXEDFRAME = SM_CXDLGFRAME
  SM_CXFRAME = 32
  SM_CXFULLSCREEN = 16
  SM_CXHSCROLL = 21
  SM_CXHTHUMB = 10
  SM_CXICON = 11
  SM_CXICONSPACING = 38
  SM_CXMIN = 28
  SM_CXMINTRACK = 34
  SM_CXSCREEN = 0
  SM_CXSIZE = 30
  SM_CXSIZEFRAME = SM_CXFRAME
  SM_CXVSCROLL = 2
  SM_CYBORDER = 6
  SM_CYCAPTION = 4
  SM_CYCURSOR = 14
  SM_CYDLGFRAME = 8
  SM_CYDOUBLECLK = 37
  SM_CYFIXEDFRAME = SM_CYDLGFRAME
  SM_CYFRAME = 33
  SM_CYFULLSCREEN = 17
  SM_CYHSCROLL = 3
  SM_CYICON = 12
  SM_CYICONSPACING = 39
  SM_CYKANJIWINDOW = 18
  SM_CYMENU = 15
  SM_CYMIN = 29
  SM_CYMINTRACK = 35
  SM_CYSCREEN = 1
  SM_CYSIZE = 31
  SM_CYSIZEFRAME = SM_CYFRAME
  SM_CYVSCROLL = 20
  SM_CYVTHUMB = 9
  SM_DBCSENABLED = 42
  SM_DEBUG = 22
  SM_MENUDROPALIGNMENT = 40
  SM_MOUSEPRESENT = 19
  SM_PENWINDOWS = 41
  SM_RESERVED1 = 24
  SM_RESERVED2 = 25
  SM_RESERVED3 = 26
  SM_RESERVED4 = 27
  SM_SWAPBUTTON = 23
End Enum

Public Enum InfoSystemColors
  COLOR_ACTIVEBORDER = 10
  COLOR_ACTIVECAPTION = 2
  COLOR_APPWORKSPACE = 12
  COLOR_BACKGROUND = 1
  COLOR_BTNFACE = 15
  COLOR_BTNHIGHLIGHT = 20
  COLOR_BTNSHADOW = 16
  COLOR_BTNTEXT = 18
  COLOR_CAPTIONTEXT = 9
  COLOR_GRAYTEXT = 17
  COLOR_HIGHLIGHT = 13
  COLOR_HIGHLIGHTTEXT = 14
  COLOR_INACTIVEBORDER = 11
  COLOR_INACTIVECAPTION = 3
  COLOR_INACTIVECAPTIONTEXT = 19
  COLOR_MENU = 4
  COLOR_MENUTEXT = 7
  COLOR_SCROLLBAR = 0
  COLOR_WINDOW = 5
  COLOR_WINDOWFRAME = 6
  COLOR_WINDOWTEXT = 8
End Enum


'------------------------------------------------------------------
' API Declarations

Private Type SYSTEMINFO_STRUCT
  dwOemId As Long
  dwPageSize As Long
  lpMinimumApplicationAddress As Long
  lpMaximumApplicationAddress As Long
  dwActiveProcessorMask As Long
  dwNumberOfProcessors As Long
  dwProcessorType As Long
  dwAllocationGranularity As Long
  dwReserved As Long
End Type

Private Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEMINFO_STRUCT)

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SetSysColors Lib "user32" (ByVal nChanges As Long, lpSysColor As Long, lpColorValues As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long


'------------------------------------------------------------------
' Get the information

Private Sub Class_Initialize()
  Me.Refresh
End Sub


'------------------------------------------------------------------
' Get the information

Public Property Get SystemColor(ColorID As InfoSystemColors) As Long
  SystemColor = GetSysColor(ColorID)
End Property

Public Property Get SystemMetric(Metric As InfoSystemMetrics) As Long
  SystemMetric = GetSystemMetrics(Metric)
End Property

Public Property Get ActiveProcessorMask() As Long
  ActiveProcessorMask = CurSysInfo.dwActiveProcessorMask
End Property

Public Property Get AllocationGranularity() As Long
  AllocationGranularity = CurSysInfo.dwAllocationGranularity
End Property

Public Property Get MinAppAddress() As Long
  MinAppAddress = CurSysInfo.lpMinimumApplicationAddress
End Property

Public Property Get MaxAppAddress() As Long
  MaxAppAddress = CurSysInfo.lpMaximumApplicationAddress
End Property

Public Property Get OemID() As Long
  OemID = CurSysInfo.dwOemId
End Property

Public Property Get PageSize()
  PageSize = CurSysInfo.dwPageSize
End Property

Public Property Get CPUCount() As Long
  CPUCount = CurSysInfo.dwNumberOfProcessors
End Property

Public Property Get CPU() As Long
  CPU = CurSysInfo.dwProcessorType
End Property


'------------------------------------------------------------------
' Get the system information again.

Public Sub Refresh()
  Call GetSystemInfo(CurSysInfo)
End Sub
