VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WinVersionInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
'
'
' 29 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



'------------------------------------------------------------------
' Local Variables

Private CurOSVer As OSVERSIONINFO
Private CurPlatform As String
Private CurBuild As String


'------------------------------------------------------------------
' API Declaratios to find windows version

Private Enum OSVerPlatFormID
  VER_PLATFORM_WIN32s = 0
  VER_PLATFORM_WIN32_WINDOWS = 1
  VER_PLATFORM_WIN32_NT = 2
End Enum

Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformID As Long
  szCSDVersion As String * 128  '  Maintenance string for PSS usage
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long


'------------------------------------------------------------------
' Get the information

Private Sub Class_Initialize()
  CurOSVer.dwOSVersionInfoSize = Len(CurOSVer)
  If GetVersionEx(CurOSVer) = 0 Then Err.Raise 12345, "Windows Version", "Could not get Windows version!"
  
  Select Case CurOSVer.dwPlatformID
    Case VER_PLATFORM_WIN32_WINDOWS
      CurPlatform = "Windows"
    Case VER_PLATFORM_WIN32_NT
      CurPlatform = "Windows NT"
    Case VER_PLATFORM_WIN32s
      CurPlatform = "Win32s" ' Impossible, VB doesn't run under Win32s
    Case Else
      CurPlatform = "Unknown"
  End Select
  
  CurBuild = Left(CurOSVer.szCSDVersion, InStr(1, CurOSVer.szCSDVersion, Chr(0)))
  CurBuild = Trim(Left(CurBuild, Len(CurBuild) - 1))
'  Me.Revision = CurOSVer.dwBuildNumber And &HFFFF&
End Sub


'------------------------------------------------------------------
' Return the information

Public Property Get Platform()
  Platform = CurPlatform
End Property

Public Property Get Major() As Long
  Major = CurOSVer.dwMajorVersion
End Property

Public Property Get Minor()
  Minor = CurOSVer.dwMinorVersion
End Property

Public Property Get Revision1() As Integer ' HiWord
  Revision1 = IIf(CurOSVer.dwBuildNumber And &H80000000, (CurOSVer.dwBuildNumber \ 65535) - 1, CurOSVer.dwBuildNumber \ 65535)
End Property

Public Property Get Revision2() As Long ' LoWord
  Revision2 = IIf(CurOSVer.dwBuildNumber And &H8000&, &H8000 Or (CurOSVer.dwBuildNumber And &H7FFF&), CurOSVer.dwBuildNumber And &HFFFF&)
End Property

Public Property Get Build() As String
  Build = CurBuild
End Property

